#include <iostream>
#include <cuda.h>
#include <stdio.h>
#include <stdlib.h>
#include <sys/time.h>
using namespace std;

__global__ void kernel_gpu(float *B0,float *B1,int N){
int i = blockIdx.x * blockDim.x + threadIdx.x;
if (i < N){
B0[i] = B1[i]-B1[i]*B1[i]+B1[i];
}
}

void kernel_cpu(float *B0,float *B1,int N){
for(int i=0;i<N;i++){
B0[i] = B1[i]-B1[i]*B1[i]+B1[i];
}
}

int main(int argc,char **argv) {
fprintf(stderr, "428 ");
int size=49455;
int intBytes = size*sizeof(int);
int floatBytes = size*sizeof(float);
float *B0;
B0 = (float *)malloc(floatBytes);
float *B1;
B1 = (float *)malloc(floatBytes);
for(int i=0;i<49455;i++){
B0[i] = 87.2660092781+i+1;
B1[i] = 39.9901827472+i+1;
}
float *d_B0;
cudaMalloc((void **)&d_B0,49455*sizeof(float));
cudaMemcpy(d_B0,B0,49455*sizeof(float),cudaMemcpyHostToDevice);
float *d_B1;
cudaMalloc((void **)&d_B1,49455*sizeof(float));
cudaMemcpy(d_B1,B1,49455*sizeof(float),cudaMemcpyHostToDevice);
int n = 194*256;
int block_size = 256;
int block_no = n/block_size;
struct timeval time0,time1;
gettimeofday(&time0,NULL);
kernel_gpu<<<block_no,block_size>>>(d_B0,d_B1,49455);
cudaThreadSynchronize();
gettimeofday(&time1,NULL);
double totaltime10 = (time1.tv_sec*1000000.0 + time1.tv_usec) - (time0.tv_sec*1000000.0 + time0.tv_usec);
fprintf(stderr, "GPU time: %lf msecs ",  (totaltime10)/1000.0F);
gettimeofday(&time0,NULL);
kernel_cpu(B0,B1,49455);
gettimeofday(&time1,NULL);
totaltime10 = (time1.tv_sec*1000000.0 + time1.tv_usec) - (time0.tv_sec*1000000.0 + time0.tv_usec);
fprintf(stderr, "CPU time: %lf msecs ",  (totaltime10)/1000.0F);
float *testB0;
testB0 = (float *)malloc(floatBytes);
cudaMemcpy(testB0,d_B0,49455*sizeof(int),cudaMemcpyDeviceToHost);
float *testB1;
testB1 = (float *)malloc(floatBytes);
cudaMemcpy(testB1,d_B1,49455*sizeof(int),cudaMemcpyDeviceToHost);
for(int i=0;i<49455;i++){
}
free(B0);
free(testB0);
cudaFree(d_B0);
free(B1);
free(testB1);
cudaFree(d_B1);
printf("\n");return 0; }